#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=ico\video.ico
#AutoIt3Wrapper_Outfile=Video-Archiv.exe
#AutoIt3Wrapper_Res_Description=Video-Archiv
#AutoIt3Wrapper_Res_Fileversion=1.1.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Oscar (www.autoit.de)
#AutoIt3Wrapper_Res_Language=1031
#AutoIt3Wrapper_UseX64=n
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <ButtonConstants.au3>
#include <File.au3>
#include <FileConstants.au3>
#include <GUIConstantsEx.au3>
#include <GuiListView.au3>
#include <GuiStatusBar.au3>
#include <ListViewConstants.au3>
#include <StructureConstants.au3>
#include <WinAPI.au3>
#include <WinAPIRes.au3>
#include <WinAPISys.au3>
#include <WinAPIMisc.au3>
#include <WindowsConstants.au3>

Opt('GUIOnEventMode', 1)

Global $sTitle = 'Video-Archiv'
Global $sVersion = '1.1.0.0'
Global $sDate = '03.10.2014'

Global $sAppDir = @AppDataDir & '\Video-Archiv\'
If Not FileExists($sAppDir) Then DirCreate($sAppDir)
Global $sIniFile = $sAppDir & 'Video-Archiv.ini'
Global $fArchivChanged = False

Global $sVLC_Player = @ProgramFilesDir & '\VideoLAN\VLC\vlc.exe', $fVLC = True
If Not FileExists($sVLC_Player) Then $fVLC = False

Global $sIconDir = @ScriptDir & '\ico\'
Global $sMediaInfoDll = @ScriptDir & '\MediaInfo\MediaInfo.dll'
If Not FileExists($sMediaInfoDll) Then Exit MsgBox(16, $sTitle, 'Die "MediaInfo.dll" konnte nicht gefunden werden!' & @CRLF & 'Bitte das Programm neu installieren!')
Global $hMediaInfoDll = DllOpen($sMediaInfoDll)
Global $sVideoDir = IniRead($sIniFile, 'Config', 'VideoDir', @DesktopDir)
Global $sLastArchive = IniRead($sIniFile, 'Config', 'LastArchive', '')
If Not FileExists($sLastArchive) Then $sLastArchive = ''
Global $oDictVideoList = ObjCreate('Scripting.Dictionary')

Global $hGui = GUICreate(StringFormat('%s   v%3.3s', $sTitle, $sVersion), 800, 600)
GUISetOnEvent($GUI_EVENT_CLOSE, '_CloseGui')
GUISetIcon($sIconDir & 'video.ico')
GUISetBkColor(0xBBBBBB)

Global $idNewArchive = GUICtrlCreateButton('  Neues Archiv' & @CRLF & '  Erstellen', 10, 10, 135, 42, BitOR($BS_MULTILINE, $BS_CENTER))
GUICtrlSetFont(-1, 9, 400, 0, 'Tahoma', 5)
GUICtrlSetImage(-1, $sIconDir & 'database_new.ico')
GUICtrlSetOnEvent(-1, '_NewArchive')
GUICtrlSetTip(-1, 'Hiermit wird ein neues Archiv erstellt.' & @CRLF & 'Achtung! Nicht gespeicherte Daten gehen verloren!')

Global $idLoadArchive = GUICtrlCreateButton('  Archiv' & @CRLF & '  Laden', 150, 10, 120, 42, BitOR($BS_MULTILINE, $BS_CENTER))
GUICtrlSetFont(-1, 9, 400, 0, 'Tahoma', 5)
GUICtrlSetImage(-1, $sIconDir & 'database_load.ico')
GUICtrlSetOnEvent(-1, '_LoadArchive')
GUICtrlSetTip(-1, 'Hiermit wird ein vorher gespeichertes Archiv geladen.' & @CRLF & 'Achtung! Bereits vorhandene Daten werden berschrieben!')

Global $idSaveArchive = GUICtrlCreateButton('Archiv' & @CRLF & '  Speichern', 275, 10, 120, 42, BitOR($BS_MULTILINE, $BS_CENTER))
GUICtrlSetFont(-1, 9, 400, 0, 'Tahoma', 5)
GUICtrlSetImage(-1, $sIconDir & 'database_save.ico')
GUICtrlSetOnEvent(-1, '_SaveArchive')
GUICtrlSetTip(-1, 'Hiermit wird das Archiv unter einem whlbaren Dateinamen gespeichert.')

Global $idAddVideo = GUICtrlCreateButton('Videos' & @CRLF & '  hinzufgen', 400, 10, 120, 42, BitOR($BS_MULTILINE, $BS_CENTER))
GUICtrlSetFont(-1, 9, 400, 0, 'Tahoma', 5)
GUICtrlSetImage(-1, $sIconDir & 'video_add.ico')
GUICtrlSetOnEvent(-1, '_AddVideo')
GUICtrlSetTip(-1, 'Hiermit knnen Videos zum Archiv hinzugefgt werden.')

Global $idDelVideo = GUICtrlCreateButton('Videos' & @CRLF & '  entfernen', 525, 10, 120, 42, BitOR($BS_MULTILINE, $BS_CENTER))
GUICtrlSetFont(-1, 9, 400, 0, 'Tahoma', 5)
GUICtrlSetImage(-1, $sIconDir & 'video_del.ico')
GUICtrlSetOnEvent(-1, '_DelVideo')
GUICtrlSetTip(-1, 'Alle markierten Videos werden aus dem Archiv entfernt.' & @CRLF & 'Sie werden nur aus dem Archiv entfernt. Nicht von der Festplatte gelscht!')

Global $idAddFolder = GUICtrlCreateButton('  Video-Ordner' & @CRLF & '  hinzufgen', 650, 10, 140, 42, BitOR($BS_MULTILINE, $BS_CENTER))
GUICtrlSetFont(-1, 9, 400, 0, 'Tahoma', 5)
GUICtrlSetImage(-1, $sIconDir & 'folder_add.ico')
GUICtrlSetOnEvent(-1, '_AddFolder')
GUICtrlSetTip(-1, 'Hiermit kann ein ganzes Video-Verzeichnis' & @CRLF & '(inkl. aller Unterverzeichnisse) dem Archiv hinzugefgt werden.')

Global $idVideoList = GUICtrlCreateListView('Video-Name|Endung|Datum|Gre|Datei', 10, 65, 780, 490, $LVS_SHOWSELALWAYS)
GUICtrlSetOnEvent(-1, '_SortList')
Global $idContextMenu = GUICtrlCreateContextMenu($idVideoList)
GUICtrlCreateMenuItem('Detail-Informationen zum Film anzeigen...', $idContextMenu)
GUICtrlSetOnEvent(-1, '_GetMediaInfo')
GUICtrlCreateMenuItem('Explorer-Fenster mit Pfad zum Film ffnen...', $idContextMenu)
GUICtrlSetOnEvent(-1, '_OpenExplorer')
_GUICtrlListView_RegisterSortCallBack($idVideoList)
Global $hWndListView = GUICtrlGetHandle($idVideoList)
_GUICtrlListView_SetColumnWidth($hWndListView, 0, 400)
_GUICtrlListView_SetColumnWidth($hWndListView, 1, 60)
_GUICtrlListView_SetColumnWidth($hWndListView, 2, 120)
_GUICtrlListView_SetColumnWidth($hWndListView, 3, 70)
_GUICtrlListView_JustifyColumn($hWndListView, 3, 1)
_GUICtrlListView_SetColumnWidth($hWndListView, 4, 340)

Global $hStatus = _GUICtrlStatusBar_Create($hGui)
Global $aParts[3] = [360, 560, 800], $ahIcons[5], $iIconSize = 24
_GUICtrlStatusBar_SetParts($hStatus, $aParts)
_GUICtrlStatusBar_SetMinHeight($hStatus, 28)
$ahIcons[0] = _WinAPI_LoadIconWithScaleDown(0, $sIconDir & 'information.ico', $iIconSize, $iIconSize)
$ahIcons[1] = _WinAPI_LoadIconWithScaleDown(0, $sIconDir & 'info_rhombus.ico', $iIconSize, $iIconSize)
$ahIcons[2] = _WinAPI_LoadIconWithScaleDown(0, $sIconDir & 'vlc_ok.ico', $iIconSize, $iIconSize)
$ahIcons[3] = _WinAPI_LoadIconWithScaleDown(0, $sIconDir & 'vlc_fail.ico', $iIconSize, $iIconSize)
$ahIcons[4] = _WinAPI_LoadIconWithScaleDown(0, $sIconDir & 'hourglass.ico', $iIconSize, $iIconSize)
_GUICtrlStatusBar_SetIcon($hStatus, 0, $ahIcons[0])
_GUICtrlStatusBar_SetIcon($hStatus, 2, $ahIcons[1])
_GUICtrlStatusBar_SetText($hStatus, 'Bereit.', 0)
_GUICtrlStatusBar_SetText($hStatus, 'Anzahl der Videos: 0', 2)
If $fVLC Then
	_GUICtrlStatusBar_SetText($hStatus, 'VLC-Player installiert!', 1)
	_GUICtrlStatusBar_SetIcon($hStatus, 1, $ahIcons[2])
Else
	_GUICtrlStatusBar_SetText($hStatus, 'VLC-Player nicht installiert!', 1)
	_GUICtrlStatusBar_SetIcon($hStatus, 1, $ahIcons[3])
EndIf
If $sLastArchive <> '' Then
	_GUICtrlListView_LoadFromFile($idVideoList, $sLastArchive, StringFormat('%s v%3.3s', $sTitle, $sVersion))
	_GUICtrlListView_SetColumnWidth($hWndListView, 4, $LVSCW_AUTOSIZE)
	_GetVideoCount()
	$fArchivChanged = True
EndIf
GUISetState(@SW_SHOW, $hGui)
GUIRegisterMsg($WM_NOTIFY, 'WM_NOTIFY')

WinWaitClose($hGui)
Exit

Func _CloseGui()
	If $fArchivChanged Then
		If MsgBox(4 + 32 + 256, $sTitle, 'Soll das Programm wirklich beendet werden?' & @CRLF & 'Achtung! Nicht gespeicherte Daten gehen verloren!', 0, $hGui) = 7 Then Return
	EndIf
	_GUICtrlListView_UnRegisterSortCallBack($idVideoList)
	IniWrite($sIniFile, 'Config', 'VideoDir', $sVideoDir)
	IniWrite($sIniFile, 'Config', 'LastArchive', $sLastArchive)
	For $i = 0 To UBound($ahIcons) - 1
		_WinAPI_DestroyIcon($ahIcons[$i])
	Next
	DllClose($hMediaInfoDll)
	GUIDelete($hGui)
EndFunc   ;==>_CloseGui

Func _SortList()
	_GUICtrlStatusBar_SetIcon($hStatus, 0, $ahIcons[4])
	_GUICtrlStatusBar_SetText($hStatus, 'Das Archiv wird sortiert. Bitte warten!', 0)
	GUISetCursor(15, 1, $hGui)
	Local $iSortCol = GUICtrlGetState($idVideoList)
	If $iSortCol = 2 Then
		_GUICtrlListView_SortGermanDate($idVideoList, $iSortCol)
	Else
		_GUICtrlListView_SortItems($idVideoList, $iSortCol)
	EndIf
	_GUICtrlStatusBar_SetIcon($hStatus, 0, $ahIcons[0])
	_GUICtrlStatusBar_SetText($hStatus, 'Bereit.', 0)
	GUISetCursor(2, 1, $hGui)
	$fArchivChanged = True
EndFunc   ;==>_SortList

Func _GUICtrlListView_SortGermanDate(ByRef $idListView, $iSortCol)
	Local $iCount = _GUICtrlListView_GetItemCount($idListView), $sItem = ''
	If $iCount < 1 Then Return SetError(1, 0, 0)
	_GUICtrlListView_BeginUpdate($idListView)
	For $i = 0 To $iCount - 1
		$sItem = _GUICtrlListView_GetItemText($idListView, $i, $iSortCol)
		$sItem = StringRegExpReplace($sItem, '(\d{2})\.(\d{2})\.(\d{4})', '$3$2$1')
		_GUICtrlListView_SetItemText($idListView, $i, $sItem, $iSortCol)
	Next
	_GUICtrlListView_SortItems($idListView, $iSortCol)
	For $i = 0 To $iCount - 1
		$sItem = _GUICtrlListView_GetItemText($idListView, $i, $iSortCol)
		$sItem = StringRegExpReplace($sItem, '(\d{4})(\d{2})(\d{2})', '$3.$2.$1')
		_GUICtrlListView_SetItemText($idListView, $i, $sItem, $iSortCol)
	Next
	_GUICtrlListView_EndUpdate($idListView)
EndFunc

Func _NewArchive()
	If MsgBox(4 + 32 + 256, $sTitle, 'Wirklich ein neues Archiv erstellen?' & @CRLF & 'Achtung! Nicht gespeicherte Daten gehen verloren!', 0, $hGui) = 7 Then Return
	_GUICtrlListView_DeleteAllItems($hWndListView)
	_GetVideoCount()
EndFunc   ;==>_NewArchive

Func _GetVideoCount()
	Local $iItemCount = _GUICtrlListView_GetItemCount($hWndListView)
	_GUICtrlStatusBar_SetText($hStatus, 'Anzahl der Videos: ' & $iItemCount, 2)
	$oDictVideoList.RemoveAll
	If $iItemCount = 0 Then Return
	For $i = 0 To $iItemCount - 1
		$oDictVideoList.Add(_GUICtrlListView_GetItemText($hWndListView, $i, 4), 1)
	Next
EndFunc   ;==>_GetVideoCount

Func _LoadArchive()
	Local $sFile = FileOpenDialog($sTitle, $sAppDir, 'Video-Archiv (*.via)', 2 + 1, '', $hGui)
	If @error Then Return
	_GUICtrlListView_LoadFromFile($idVideoList, $sFile, StringFormat('%s v%3.3s', $sTitle, $sVersion))
	_GUICtrlListView_SetColumnWidth($hWndListView, 4, $LVSCW_AUTOSIZE)
	_GetVideoCount()
	$fArchivChanged = True
	$sLastArchive = $sFile
EndFunc   ;==>_LoadArchive

Func _GUICtrlListView_LoadFromFile($idListView, $sFilename, $sIdentifier = '')
	If Not FileExists($sFilename) Then Return SetError(1, 0, 0)
	Local $sFile = FileRead($sFilename)
	Local $aItems = StringSplit($sFile, @CRLF, 1)
	If Not IsArray($aItems) Then Return SetError(2, 0, 0)
	If $sIdentifier <> '' Then
		If $aItems[1] <> $sIdentifier Then Return SetError(3, 0, 0)
	EndIf
	_GUICtrlListView_DeleteAllItems($hWndListView)
	For $i = 2 To $aItems[0] - 1
		GUICtrlCreateListViewItem($aItems[$i], $idListView)
	Next
EndFunc   ;==>_GUICtrlListView_LoadFromFile

Func _SaveArchive()
	Local $iItemCount = _GUICtrlListView_GetItemCount($hWndListView)
	If $iItemCount = 0 Then Return SetError(1, 0, 0)
	Local $sFile = FileSaveDialog($sTitle, $sAppDir, 'Video-Archiv (*.via)', 2 + 16, '', $hGui)
	If @error Then Return
	If StringRight($sFile, 4) <> '.via' Then $sFile &= '.via'
	_GUICtrlListView_SaveToFile($idVideoList, $sFile, StringFormat('%s v%3.3s\r\n', $sTitle, $sVersion))
	$fArchivChanged = False
	$sLastArchive = $sFile
EndFunc   ;==>_SaveArchive

Func _GUICtrlListView_SaveToFile($idListView, $sFilename, $sIdentifier = @CRLF)
	Local $iItemCount = _GUICtrlListView_GetItemCount($hWndListView)
	If $iItemCount = 0 Then Return SetError(1, 0, 0)
	Local $sOutput = $sIdentifier
	For $i = 0 To $iItemCount - 1
		$sOutput &= _GUICtrlListView_GetItemTextString($hWndListView, $i) & @CRLF
	Next
	Local $hFile = FileOpen($sFilename, 2 + 8)
	If $hFile = -1 Then Return SetError(2, 0, 0)
	FileWrite($hFile, $sOutput)
	FileClose($hFile)
	Return SetError(0, 0, 1)
EndFunc   ;==>_GUICtrlListView_SaveToFile

Func _AddVideo()
	Local $sVideoFiles = FileOpenDialog('Bitte die Videos auswhlen!', $sVideoDir, 'Videos (*.avi;*.flv;*.mkv;*.mov;*.mpg;*.mpeg;*.mp4;*.wmv)', 5, '', $hGui)
	If @error Then Return
	$sVideoDir = @WorkingDir
	Local $aVideos = StringSplit($sVideoFiles, '|', 2), $sVideoName = '', $sVideoExt = '', $sFileCreateTime = '', $sFileSize = ''
	If UBound($aVideos) = 1 Then
		If Not $oDictVideoList.Exists($aVideos[0]) Then
			$oDictVideoList.Add($aVideos[0], 1)
			$sVideoName = StringRegExpReplace($aVideos[0], '.+\\(.+)\..+', '$1')
			$sVideoExt = StringRegExpReplace($aVideos[0], '.+\\.+\.(.+)', '$1')
			$sFileCreateTime = StringRegExpReplace(FileGetTime($aVideos[0], 1, 1), '(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})', '$3.$2.$1  $4:$5:$6')
			$sFileSize = _WinAPI_StrFormatByteSize(FileGetSize($aVideos[0]))
			GUICtrlCreateListViewItem($sVideoName & '|' & $sVideoExt & '|' & $sFileCreateTime & '|' & $sFileSize & '|' & $aVideos[0], $idVideoList)
		EndIf
	Else
		If StringRight($aVideos[0], 1) <> '\' Then $aVideos[0] &= '\'
		For $i = 1 To UBound($aVideos) - 1
			If Not $oDictVideoList.Exists($aVideos[0] & $aVideos[$i]) Then
				$oDictVideoList.Add($aVideos[0] & $aVideos[$i], 1)
				$sVideoName = StringRegExpReplace($aVideos[$i], '(.+)\..+', '$1')
				$sVideoExt = StringRegExpReplace($aVideos[$i], '.+\.(.+)', '$1')
				$sFileCreateTime = StringRegExpReplace(FileGetTime($aVideos[$i], 1, 1), '(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})', '$3.$2.$1  $4:$5:$6')
				$sFileSize = _WinAPI_StrFormatByteSize(FileGetSize($aVideos[$i]))
				GUICtrlCreateListViewItem($sVideoName & '|' & $sVideoExt & '|' & $sFileCreateTime & '|' & $sFileSize & '|' & $aVideos[0] & $aVideos[$i], $idVideoList)
			EndIf
		Next
	EndIf
	_GUICtrlListView_SetColumnWidth($hWndListView, 4, $LVSCW_AUTOSIZE)
	_GetVideoCount()
	$fArchivChanged = True
EndFunc   ;==>_AddVideo

Func _DelVideo()
	_GUICtrlListView_DeleteItemsSelected($hWndListView)
	_GetVideoCount()
	$fArchivChanged = True
EndFunc   ;==>_DelVideo

Func _AddFolder()
	Local $sFolder = FileSelectFolder('Bitte das Video-Verzeichnis auswhlen! Alle Videodateien in diesem Verzeichnis werden hinzugefgt.', $sVideoDir, 2, '', $hGui)
	If Not FileExists($sFolder) Then Return
	_GUICtrlStatusBar_SetIcon($hStatus, 0, $ahIcons[4])
	_GUICtrlStatusBar_SetText($hStatus, 'Das Verzeichnis wird eingelesen. Bitte warten!', 0)
	GUISetCursor(15, 1, $hGui)
	Local $aVideos = _FileListToArrayRec($sFolder, '*.avi;*.flv;*.mkv;*.mov;*.mpg;*.mpeg;*.mp4;*.wmv', $FLTAR_FILES + $FLTAR_NOSYSTEM, $FLTAR_RECUR, $FLTAR_SORT, $FLTAR_FULLPATH)
	Local $sVideoName = '', $sVideoExt = '', $sFileCreateTime = ''
	$sVideoDir = $sFolder
	For $i = 1 To $aVideos[0]
		If Not $oDictVideoList.Exists($aVideos[$i]) Then
			$oDictVideoList.Add($aVideos[$i], 1)
			$sVideoName = StringRegExpReplace($aVideos[$i], '.+\\(.+)\..+', '$1')
			$sVideoExt = StringRegExpReplace($aVideos[$i], '.+\\.+\.(.+)', '$1')
			$sFileCreateTime = StringRegExpReplace(FileGetTime($aVideos[$i], 1, 1), '(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})', '$3.$2.$1  $4:$5:$6')
			$sFileSize = _WinAPI_StrFormatByteSize(FileGetSize($aVideos[$i]))
			GUICtrlCreateListViewItem($sVideoName & '|' & $sVideoExt & '|' & $sFileCreateTime & '|' & $sFileSize & '|' & $aVideos[$i], $idVideoList)
		EndIf
	Next
	_GUICtrlListView_SetColumnWidth($hWndListView, 4, $LVSCW_AUTOSIZE)
	_GetVideoCount()
	$fArchivChanged = True
	GUISetCursor(2, 1, $hGui)
	_GUICtrlStatusBar_SetIcon($hStatus, 0, $ahIcons[0])
	_GUICtrlStatusBar_SetText($hStatus, 'Bereit.', 0)
EndFunc   ;==>_AddFolder

Func WM_NOTIFY($hWnd, $iMsg, $wParam, $lParam)
	#forceref $hWnd, $iMsg, $wParam
	Local Static $iStartIndex = -1, $iEndIndex = -1, $sItemText = "", $fLVDrag = False
	Local $hWndFrom, $iCode, $tNMHDR, $tInfo, $iIndex, $sVideoFile, $iNewItem, $tNMLISTVIEW
	$tNMHDR = DllStructCreate($tagNMHDR, $lParam)
	$hWndFrom = HWnd(DllStructGetData($tNMHDR, 'hWndFrom'))
	$iCode = DllStructGetData($tNMHDR, 'Code')
	Switch $hWndFrom
		Case $hWndListView
			Switch $iCode
				Case $NM_DBLCLK
					$tInfo = DllStructCreate($tagNMITEMACTIVATE, $lParam)
					$iIndex = DllStructGetData($tInfo, 'Index')
					$sVideoFile = _GUICtrlListView_GetItemText($hWndListView, $iIndex, 4)
					If FileExists($sVideoFile) Then
						ConsoleWrite('Play: "' & $sVideoFile & '"' & @CR)
						If $fVLC Then
							Run($sVLC_Player & ' --fullscreen "' & $sVideoFile & '"')
						Else
							ShellExecute('"' & $sVideoFile & '"')
						EndIf
					EndIf
				Case $LVN_BEGINDRAG
					If Not $fLVDrag Then
						$tNMLISTVIEW = DllStructCreate($tagNMLISTVIEW, $lParam)
						$iStartIndex = DllStructGetData($tNMLISTVIEW, 'Item')
						$sItemText = _GUICtrlListView_GetItemTextString($hWndListView, $iStartIndex)
						$fLVDrag = True
					EndIf
				Case $LVN_HOTTRACK
					If $fLVDrag Then
						$tNMLISTVIEW = DllStructCreate($tagNMLISTVIEW, $lParam)
						$iEndIndex = DllStructGetData($tNMLISTVIEW, 'Item')
						$fLVDrag = False
						Select
							Case $iStartIndex < $iEndIndex
								$iNewItem = _GUICtrlListView_InsertItem($hWndListView, "", $iEndIndex + 1)
								_GUICtrlListView_SetItemText($hWndListView, $iNewItem, $sItemText, -1)
								_GUICtrlListView_SetItemSelected($hWndListView, $iNewItem, True, True)
								_GUICtrlListView_DeleteItem($hWndListView, $iStartIndex)
							Case $iStartIndex > $iEndIndex
								_GUICtrlListView_DeleteItem($hWndListView, $iStartIndex)
								$iNewItem = _GUICtrlListView_InsertItem($hWndListView, "", $iEndIndex)
								_GUICtrlListView_SetItemText($hWndListView, $iNewItem, $sItemText, -1)
								_GUICtrlListView_SetItemSelected($hWndListView, $iNewItem, True, True)
						EndSelect
						$fArchivChanged = True
					EndIf
			EndSwitch
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_NOTIFY

Func _OpenExplorer()
	Local $iSelItem = ControlListView($hGui, '', $idVideoList, 'GetSelected', 0)
	If $iSelItem = '' Then Return
	Local $sFilename = _GUICtrlListView_GetItemText($hWndListView, $iSelItem, 4)
	Run('explorer.exe ' & StringRegExpReplace($sFilename, '(.+)\\.+', '$1'))
EndFunc

Func _GetMediaInfo()
	Local $iSelItem = ControlListView($hGui, '', $idVideoList, 'GetSelected', 0)
	If $iSelItem = '' Then Return
	Local $sFilename = _GUICtrlListView_GetItemText($hWndListView, $iSelItem, 4)
	; New MediaInfo handle
	Local $aMediaInfo = DllCall($hMediaInfoDll, 'ptr', 'MediaInfo_New')
	Local $hMediaInfo = $aMediaInfo[0]
	; Open
	DllCall($hMediaInfoDll, 'dword', 'MediaInfo_Open', _
			'ptr', $hMediaInfo, _ ; Handle
			'wstr', $sFilename) ; Full path
	; General MediaInfo
	Local $aMediaInfoInform = DllCall($hMediaInfoDll, 'wstr', 'MediaInfo_Inform', _
			'ptr', $hMediaInfo, _ ; Handle
			'int', 0) ; Options
	Local $sMediaInfoInform = $aMediaInfoInform[0]
	DllCall($hMediaInfoDll, 'none', 'MediaInfo_Close', 'ptr', $hMediaInfo)
	_StringDisplay($sMediaInfoInform)
EndFunc

Func _StringDisplay($sText)
	Local $iEventMode = Opt('GUIOnEventMode', 0), $msg, $iWidth = 720, $iHeight = 480, $iLeft = -1, $iTop = -1
	Local $hDisplayGui = GUICreate('Detail-Informationen', $iWidth, $iHeight, $iLeft, $iTop, BitOR($WS_MINIMIZEBOX, $WS_MAXIMIZEBOX, $WS_SIZEBOX), -1, $hGui)
	GUISetIcon($sIconDir & 'video.ico')
	GUISetFont(10, 400, 0, 'Courier New', $hDisplayGui, 5)
	Local $hEdit = GUICtrlCreateEdit($sText, 5, 5, $iWidth - 10, $iHeight - 65)
	GUICtrlSetResizing(-1, 2 + 4 + 32 + 64)
	Local $hClose = GUICtrlCreateButton('Close', $iWidth / 2 - 25, $iHeight - 55, 50, 22, $BS_DEFPUSHBUTTON)
	GUICtrlSetResizing(-1, 64 + 256 + 512)
	ControlFocus($hDisplayGui, '', $hClose)
	GUISetState(@SW_SHOW, $hDisplayGui)
	Do
		$msg = GUIGetMsg()
	Until $msg = $hClose Or $msg = $GUI_EVENT_CLOSE
	GUIDelete($hDisplayGui)
	Opt('GUIOnEventMode', $iEventMode)
EndFunc   ;==>_StringDisplay
